#include "messages.h"

Messages::Messages()
{
    LogWrite ("Creado Gestor de mensajes.\n");
}


Messages::~Messages()
{
    LogWrite ("Destruido Gestor de mensajes.\n");
}

int Messages::Init (int Lang)
{
    char FileName[20];
    ifstream Source;
    int Ret = 0, Cont = 0;
    string Buffer;

    if (!MaxMens)
	   return 0;

    sprintf (FileName, "./lang/lang%i.txt", Lang);
    LogWrite ("Intentando cargar mensajes de %s...", FileName);
    Source.open (FileName);
    if (Source.fail()) {
        LogWrite ("ERROR.\nNo se pueden cargar mensajes de texto.\n");
        return -1;
	    }

    while (Cont < MaxMens && !Source.eof() ) {
	getline (Source, Buffer);
	while (Buffer.length() && Buffer.substr (0,1) == " ")
	      Buffer = Buffer.substr (1, Buffer.length() - 1);
	if (Buffer.length() > 1 && Buffer.substr (0, 1) != "#") {
	    Mensajes[Cont++] = Buffer;
	    if (*((char*) (Mensajes[Cont-1].substr (Mensajes[Cont-1].length() - 1, 1)).c_str()) == 13) // si mete el retorno de carro como caracter en la cadena
		    Mensajes [Cont-1] = Mensajes [Cont-1].substr (0, Mensajes[Cont-1].length () - 1); // Asi que hay que quitarlo :)
	    }
	}

    LogWrite ("\n %i mensajes cargados correctamente de %i esperados.\n", Cont, MaxMens);

    Source.close();

    if (Cont < MaxMens)
	Ret = 1;

    return Ret;
}

int Messages::InitMens(int Lang)
{
    if (!Init (Lang))
       return 0;
    Config->ToggleIdioma (0);
    return Init(0);
}

const char* Messages::ReadMens(int Num)
{
     if (Num < MaxMens)
        return Mensajes[Num].c_str();
     return NULL;
}

const char* Messages::ReadName (int Num)
{
/* Meter a
.- Litos.net
*/

      const char* Nombres[] = {
            "CEZ Team",
            "Alejandro Layunta Villarejo - Alx",
            "ngel L Prez - Anjuel",
            "Augusto Ruiz - AugustoRuiz",
            "David Caadas Mazo - DavidCM",
            "Daniel Celemn Garca - LordFred",
            "David Donaire - DadMan",
            "Ivn Snchez Jord - IvanZX",
            "Luis I. Garca Ventura - Benway",
            "Miguel . Gonzlez lvarez - Zikitrake",
            "Jaime Tejedor Gmez - Metalbrain",
            "Jos Andrs Gil Ayube - Konamito",
            "Jos Juan Rdenas - Sejuan",
            "Jos Luis Veiga Sierra - Karnevi",
            "Jos Vicente Mas - Wyz",
            "Xavier Ortiz Carrasco - TBrazil",
            "Jose Ignacio Ramos - Kendroock",
            "Jos Luis Castao - Na_th_an",
            "Ral Molina Guerrero - Zemman",
            "Ral Montn - The Punisher",
            "Fran Crespo - Black Hole",
            "Francisco Javier Velasco - Pagantipaco",
	        "Manuel Sagra - Edge",
	        "Alberto Riera - [[c|-|e]]",
            "Fernando Daz Jordn - Onofre",
            "Nacho Esperidn - Mandrake el Mago",
            "lvaro Mateos",
            "ngel Tirado",
            "Jos Ramn Prez",
            "Manul Gasc",
            "Rafael Garca",
            "David Brioso",
            "ngel Macedo",
            "Manuel Guilln",
            "Francisco Gmez",
            "Francisco Rodrguez",
            "Traperic",
            "Santiago Ontan Villar - Popolon",
            "Lennart Steinke",
            "Marta Rodrguez Iglesias",
            "Manuel Pazos - Guillian"
            };
      return Nombres [Num];
}

const char* Messages::ReadDedic (int Num)
{

      const char* Nombres[] = {
            "Mara Rengel Arribas",
            "Sin t hubiera sido imposible",
            "terminar esto nunca.",
            "Gracias por estar a mi lado.",
            "Emma",
            "Finalmente consigui",
            "abstraerse de mi",
            "alter ego."
            };
      return Nombres [Num];
}

const char* Messages::ReadNameS (int Num)
{

      const char* Nombres[] = {
            "Achintya",
            "Anton",
            "Banco de imgenes y sonidos - Ministerio de Educacin",
            "batchku",
            "Benboncan",
            "bullshit99",
            "Connum",
            "fonogeno",
            "HardPCM",
            "harri",
            "ignotus",
            "jobro",
            "Jovica",
            "melack",
            "memexikon",
            "mich3d",
            "patchen",
            "reinsamba",
            "roscoetoon",
            "Sea Fury",
            "thannvanispen",
            "THE_bizniss",
            "tigersound",
            "UATaudio",
            "zippi1"
            };

      return Nombres [Num];
}

